## got 0.86

=== debian/changelog ===
got (0.86-1) unstable; urgency=medium

  * New upstream release

 -- Tobias Heider <me@tobhe.de>  Sun, 26 Mar 2023 14:52:37 +0200

got (0.84.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1031029)

 -- Tobias Heider <me@tobhe.de>  Sat, 25 Feb 2023 23:40:53 +0100
