## got 0.91

=== debian/changelog ===
got (0.91-1) unstable; urgency=medium

  * New upstream release 0.91
  * Update copyright for 0.91

 -- Tobias Heider <me@tobhe.de>  Fri, 21 Jul 2023 16:01:19 +0200

got (0.90-1) unstable; urgency=medium

  * New upstream release 0.90

 -- Tobias Heider <me@tobhe.de>  Fri, 30 Jun 2023 11:18:32 +0200

got (0.89-1) unstable; urgency=medium

  * New upstream release 0.89

 -- Tobias Heider <me@tobhe.de>  Fri, 09 Jun 2023 12:17:38 +0200

got (0.88-1) unstable; urgency=medium

  * New upstream release

 -- Tobias Heider <me@tobhe.de>  Sun, 07 May 2023 14:17:41 +0200
