## got 0.95

=== debian/changelog ===
got (0.95-1build1) noble; urgency=medium

  * No-change rebuild for libevent t64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 01 Apr 2024 10:15:08 +0200

got (0.95-1) unstable; urgency=medium

  [ Ryan Kavanagh ]
  * Update copyright years

  [ Tobias Heider ]
  * New upstream version 0.95
  * Silence lintian warnings

 -- Tobias Heider <me@tobhe.de>  Mon, 11 Dec 2023 14:00:41 +0100

got (0.94-1) unstable; urgency=medium

  * New upstream version 0.94

 -- Tobias Heider <me@tobhe.de>  Fri, 01 Dec 2023 14:30:52 +0100

got (0.93-1) unstable; urgency=medium

  * New upstream release 0.93
  * Install gotd example config with dh_installexamples(1)
  * Add new gotd binary package for Game of Trees daemon

 -- Tobias Heider <me@tobhe.de>  Fri, 29 Sep 2023 15:18:57 +0200
