=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

confflags += --enable-gotd
confflags += --with-gotd-empty-path=/var/lib/gotd/empty

%:
	dh $@ --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- $(confflags)

override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start
