## got 0.100

=== debian/changelog ===
got (0.100-1) unstable; urgency=medium

  * New upstream version 0.100
  * Update copyright for new additions

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Jun 2024 23:29:58 +0200

got (0.99-1) unstable; urgency=medium

  * New upstream version 0.99

 -- Tobias Heider <me@tobhe.de>  Mon, 13 May 2024 08:31:09 +0200

got (0.98.2-1) unstable; urgency=medium

  * New upstream version 0.98.2
  * Install new libexec helper binaries in got and gotd
  * Update and deduplicate copyright
  * Fix man page reference in gotd.README.debian
  * Drop --without autoreconf 

 -- Tobias Heider <me@tobhe.de>  Fri, 26 Apr 2024 16:39:45 +0200

got (0.97-1) unstable; urgency=medium

  * New upstream version 0.97
  * Update pkg-config to pkgconf

 -- Tobias Heider <me@tobhe.de>  Sun, 24 Mar 2024 19:06:13 +0100

got (0.96-1) unstable; urgency=medium

  * New upstream version 0.96

 -- Tobias Heider <me@tobhe.de>  Mon, 04 Mar 2024 17:13:06 +0100
