## got 0.103

=== regress/Makefile ===
SUBDIR = cmdline delta deltify idset path fetch tog secrets

.if make(clean)
SUBDIR += gotd 
.endif

.include <bsd.subdir.mk>
