=== regress/gotd/Makefile ===
--- 
+++ 
@@ -6,11 +6,12 @@
 	test_repo_write test_repo_write_empty test_request_bad \
 	test_repo_write_protected test_repo_write_readonly \
 	test_email_notification test_http_notification \
-	test_git_interop test_email_and_http_notification
+	test_git_interop test_email_and_http_notification \
+	test_http_notification_hmac
 NOOBJ=Yes
-CLEANFILES=gotd.conf
-
-.PHONY: ensure_root prepare_test_repo check_test_repo start_gotd
+CLEANFILES=gotd.conf gotd-secrets.conf
+
+.PHONY: ensure_root ensure_secrets prepare_test_repo check_test_repo start_gotd
 
 GOTD_TEST_ROOT=/tmp
 GOTD_DEVUSER?=gotdev
@@ -20,6 +21,7 @@
 GOTD_TEST_REPO_URL=ssh://${GOTD_DEVUSER}@127.0.0.1/$(GOTD_TEST_REPO_NAME)
 GOTD_TEST_SMTP_PORT=2525
 GOTD_TEST_HTTP_PORT=8000
+GOTD_TEST_HMAC_SECRET!=openssl rand -base64 32
 
 GOTD_TEST_USER?=${DOAS_USER}
 .if empty(GOTD_TEST_USER)
@@ -58,6 +60,7 @@
 	GOTD_CONF=$(PWD)/gotd.conf \
 	GOTD_TEST_SMTP_PORT=$(GOTD_TEST_SMTP_PORT) \
 	GOTD_TEST_HTTP_PORT=$(GOTD_TEST_HTTP_PORT) \
+	GOTD_TEST_HMAC_SECRET=$(GOTD_TEST_HMAC_SECRET) \
 	HOME=$(GOTD_TEST_USER_HOME) \
 	PATH=$(GOTD_TEST_USER_HOME)/bin:$(PATH)
 
@@ -71,6 +74,12 @@
 		false; \
 	fi
 
+ensure_secrets:
+	@echo 'auth flan user flan password password' > $(PWD)/gotd-secrets.conf
+	@echo 'hmac flan ${GOTD_TEST_HMAC_SECRET}' >> $(PWD)/gotd-secrets.conf
+	@chown root:0 $(PWD)/gotd-secrets.conf
+	@chmod 600 $(PWD)/gotd-secrets.conf
+
 start_gotd_ro: ensure_root
 	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
 	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
@@ -183,32 +192,45 @@
 	@$(GOTD_TRAP); $(GOTD_START_CMD)
 	@$(GOTD_TRAP); sleep .5
 
-start_gotd_http_notification: ensure_root
-	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
-	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
-	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
-	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
-	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    notify {' >> $(PWD)/gotd.conf
-	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
-	@echo "    }" >> $(PWD)/gotd.conf
-	@echo "}" >> $(PWD)/gotd.conf
-	@$(GOTD_TRAP); $(GOTD_START_CMD)
-	@$(GOTD_TRAP); sleep .5
-
-start_gotd_email_and_http_notification: ensure_root
-	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
-	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
-	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
-	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
-	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    notify {' >> $(PWD)/gotd.conf
-	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" user flan password "password" insecure' >> $(PWD)/gotd.conf
+start_gotd_http_notification: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure' >> $(PWD)/gotd.conf
+	@echo "    }" >> $(PWD)/gotd.conf
+	@echo "}" >> $(PWD)/gotd.conf
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
+	@$(GOTD_TRAP); sleep .5
+
+start_gotd_email_and_http_notification: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure' >> $(PWD)/gotd.conf
 	@echo -n '      email to ${GOTD_DEVUSER}' >> $(PWD)/gotd.conf
 	@echo ' relay 127.0.0.1 port ${GOTD_TEST_SMTP_PORT}' >> $(PWD)/gotd.conf
 	@echo "    }" >> $(PWD)/gotd.conf
 	@echo "}" >> $(PWD)/gotd.conf
-	@$(GOTD_TRAP); $(GOTD_START_CMD)
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
+	@$(GOTD_TRAP); sleep .5
+
+start_gotd_http_notification_hmac: ensure_root ensure_secrets
+	@echo 'listen on "$(GOTD_SOCK)"' > $(PWD)/gotd.conf
+	@echo "user $(GOTD_USER)" >> $(PWD)/gotd.conf
+	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
+	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
+	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
+	@echo '    notify {' >> $(PWD)/gotd.conf
+	@echo '         url "http://localhost:${GOTD_TEST_HTTP_PORT}/" auth flan insecure hmac flan' >> $(PWD)/gotd.conf
+	@echo "    }" >> $(PWD)/gotd.conf
+	@echo "}" >> $(PWD)/gotd.conf
+	@$(GOTD_TRAP); $(GOTD_START_CMD) -s $(PWD)/gotd-secrets.conf
 	@$(GOTD_TRAP); sleep .5
 
 prepare_test_repo: ensure_root
@@ -274,27 +296,3 @@
 	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
 	
 test_repo_write_readonly: prepare_test_repo_empty start_gotd_implicit_ro
-	@-$(GOTD_TRAP); su ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./repo_write_readonly.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-	@su -m ${GOTD_USER} -c 'env $(GOTD_TEST_ENV) sh ./check_test_repo.sh'
-
-test_request_bad: prepare_test_repo_empty start_gotd_ro
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./request_bad.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_email_notification: prepare_test_repo start_gotd_email_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./email_notification.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_http_notification: prepare_test_repo start_gotd_http_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./http_notification.sh'
-	@$(GOTD_STOP_CMD) 2>/dev/null
-
-test_email_and_http_notification: prepare_test_repo start_gotd_email_and_http_notification
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
-		'env $(GOTD_TEST_ENV) sh ./http_notification.sh test_file_changed'
-	@-$(GOTD_TRAP); su -m ${GOTD_TEST_USER} -c \
