=== debian/changelog ===
got (0.103-1) unstable; urgency=medium

  * New upstream version 0.103
  * Install gotd-secrets.conf(5) with gotd

 -- Tobias Heider <me@tobhe.de>  Tue, 10 Sep 2024 19:36:40 +0200
