## got 0.106

=== debian/changelog ===
got (0.106-1) unstable; urgency=medium

  * New upstream version 0.106

 -- Tobias Heider <me@tobhe.de>  Fri, 29 Nov 2024 15:10:43 +0100
