=== regress/gotd/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 GOTD_TEST_ROOT=/tmp
 GOTD_DEVUSER?=gotdev
 GOTD_DEVUSER_HOME!=getent passwd $(GOTD_DEVUSER) | cut -d: -f6
-GOTD_TEST_REPO!?=mktemp -d "$(GOTD_TEST_ROOT)/gotd-test-repo-XXXXXXXXXX"
+GOTD_TEST_REPO!!=mktemp -d "$(GOTD_TEST_ROOT)/gotd-test-repo-XXXXXXXXXX"
 GOTD_TEST_REPO_NAME=test-repo
 GOTD_TEST_REPO_URL=ssh://${GOTD_DEVUSER}@127.0.0.1/$(GOTD_TEST_REPO_NAME)
 GOTD_TEST_SMTP_PORT=2525
@@ -48,7 +48,7 @@
 GOTD_STOP_CMD?=$(BINDIR)/gotctl -f $(GOTD_SOCK) stop
 GOTD_TRAP=trap "$(GOTD_STOP_CMD)" HUP INT QUIT PIPE TERM
 
-GOTD_ENV=GOT_NOTIFY_EMAIL_TIMEOUT=1
+GOTD_ENV=GOT_NOTIFY_TIMEOUT=10
 
 GOTD_TEST_ENV=GOTD_TEST_ROOT=$(GOTD_TEST_ROOT) \
 	GOTD_TEST_REPO_URL=$(GOTD_TEST_REPO_URL) \
@@ -171,9 +171,9 @@
 	@echo 'repository "test-repo" {' >> $(PWD)/gotd.conf
 	@echo '    path "$(GOTD_TEST_REPO)"' >> $(PWD)/gotd.conf
 	@echo '    permit rw $(GOTD_DEVUSER)' >> $(PWD)/gotd.conf
-	@echo '    protect branch "foo"' >> $(PWD)/gotd.conf
+	@echo '    protect branch foo' >> $(PWD)/gotd.conf
 	@echo '    protect tag namespace "refs/tags/"' >> $(PWD)/gotd.conf
-	@echo '    protect branch "refs/heads/main"' >> $(PWD)/gotd.conf
+	@echo '    protect { branch refs/heads/main }' >> $(PWD)/gotd.conf
 	@echo "}" >> $(PWD)/gotd.conf
 	@$(GOTD_TRAP); $(GOTD_START_CMD)
 	@$(GOTD_TRAP); sleep .5
