=== debian/changelog ===
got (0.109-3) unstable; urgency=medium

  * Fix bug in got clone/fetch against Git servers which do not speak English

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Mar 2025 16:43:00 +0100

got (0.109-2) unstable; urgency=medium

  * Backport inifinte loop regression fix from 0.110

 -- Tobias Heider <me@tobhe.de>  Thu, 13 Mar 2025 16:20:01 +0100

got (0.109-1) unstable; urgency=medium

  * Update copyright
  * New upstream version 0.109

 -- Tobias Heider <me@tobhe.de>  Tue, 11 Mar 2025 00:22:46 +0100
