=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: misc
 Priority: optional
 Maintainer: Tobias Heider <me@tobhe.de>
-Build-Depends: debhelper-compat (= 13), pkg-config, libbsd-dev, libmd-dev,
- libncurses-dev, libevent-dev, uuid-dev, zlib1g-dev, libssl-dev, bison
+Build-Depends: debhelper-compat (= 13), pkgconf, libbsd-dev, libmd-dev,
+ libncurses-dev, libevent-dev, libtls-dev, uuid-dev, zlib1g-dev, libssl-dev,
+ bison
 Standards-Version: 4.6.2
 Homepage: https://gameoftrees.org/index.html
 Vcs-Browser: https://salsa.debian.org/debian/got
