=== debian/changelog ===
got (0.111-1) unstable; urgency=medium

  * New upstream version 0.111
  * Bump standards to 4.7.2
  * Drop upstreamed patches

 -- Tobias Heider <me@tobhe.de>  Wed, 30 Apr 2025 15:25:31 +0200
