=== debian/watch ===
version=4

https://gameoftrees.org/releases/portable/got-portable-(.+).tar.gz
